function J=Jmerry(c,w,nu,delta,ssx,Rn)
% J = Jmerry(c,w,nu,delta,ssx,Rn)
%
%     c = h*w = shortened channel
%     w = TEQ
%     nu = CP length
%     delta = symbol synchronization parameter
%     ssx = sigma_x^2 = transmitted signal power
%     Rn = noise autocorrelation matrix
%     J = Merry cost
%
%     RKM 02/11/2002
%
%     Copyright 2002 Cornell University, All Rights Reserved
%
%     SOFTWARE shall mean "Jmerry.m", Cornell Research Foundation
%     ("CRF") Docket D-3010.  SOFTWARE is made available to allow
%     non-commercial and research use of SOFTWARE.  Cornell
%     University specifically reserves all commercial rights to
%     SOFTWARE and these rights may be licensed by CRF on behalf
%     of Cornell University to third parties.
%
%     CRF provides SOFTWARE on an ``as is'' basis.  CRF does not
%     warrant, guarantee, or make any representations regarding
%     the use or results of SOFTWARE with respect to its
%     correctness, accuracy, reliability or performance.  The
%     entire risk of the use and performance of SOFTWARE is
%     assumed by EVALUATOR.  ALL WARRANTIES INCLUDING, WITHOUT
%     LIMITATION, ANY WARRANTY OF FITNESS  FOR A PARTICULAR
%     PURPOSE OR MERCHANTABILITY ARE HEREBY EXCLUDED.

c = c(:);
w = w(:);
T = length(w);
L = length(c)-T+1;

J = 2*ssx*sum(c([1:delta,nu+delta+1:T+L-1]).^2) + w.'*Rn*conj(w);
