function [w,SSNR]=merryopt(c,nu,Lw,winstart,g)
% [w,SSNR]=merryopt(c,nu,Lw,winstart,g)
%     w = TEQ
%     SSNR = cost
%     c = channel
%     nu+1 = desired window size
%     Lw = equalizer length
%     winstart = index of first sample in window
%     g = sigma_n^2 / sigma_x^2 = 1/SNR
%
%     RKM created on 05/18/2001
%     revised on 01/31/2002
%     Computes optimal Merry equalizer
%
%     Copyright 2002 Cornell University, All Rights Reserved
%
%     SOFTWARE shall mean "merryopt.m", Cornell Research Foundation
%     ("CRF") Docket D-3010.  SOFTWARE is made available to allow
%     non-commercial and research use of SOFTWARE.  Cornell
%     University specifically reserves all commercial rights to
%     SOFTWARE and these rights may be licensed by CRF on behalf
%     of Cornell University to third parties.
%
%     CRF provides SOFTWARE on an ``as is'' basis.  CRF does not
%     warrant, guarantee, or make any representations regarding
%     the use or results of SOFTWARE with respect to its
%     correctness, accuracy, reliability or performance.  The
%     entire risk of the use and performance of SOFTWARE is
%     assumed by EVALUATOR.  ALL WARRANTIES INCLUDING, WITHOUT
%     LIMITATION, ANY WARRANTY OF FITNESS  FOR A PARTICULAR
%     PURPOSE OR MERCHANTABILITY ARE HEREBY EXCLUDED.

c = c(:);
H = convmtx(c,Lw);
[n,m] = size(H);
%Hwin = H([winstart:winstart+nu]',:);
%Hwall = H([1:winstart-1,winstart+nu+1,n]',:);

Hwall = H;
Hwall([winstart:winstart+nu]',:) = zeros(nu+1,Lw);
Hwin = H-Hwall;

A = Hwall'*Hwall + g*eye(m);
%B = Hwin'*Hwin;

%[U,S,V] = svd(Hwall);
%SS = S'*S;
%D = diag(SS);
%[dummy,ind] = min(abs(D));
%w = V(:,ind);

[U,S,V] = svd(A);
D = diag(S);
[dummy,ind] = min(abs(D));
w = U(:,ind);

hwall = Hwall*w;
hwin = Hwin*w;
%h = conv(c,w);

ein = real(hwin'*hwin);
eout = real(hwall'*hwall);
SSNR = ein/eout;

%SSNR2 = ssnr(h,winstart,winstart+nu)

%keyboard

%figure(5); semilogy(D);
